import numpy as np
import math
# ---- Task (a) -------
# Do as directed in function:
# 'my_list': a list of 25 integers
def avada_kedavra(my_list):
	# Create an array 'a0' from this list 'my_list'
	a0=my_list.copy()
	

	# print a0
	print("a0 at beginning:\n{}".format(a0))

	# reshape a0 to create a 5X5 matrix a1
	a1=a0.reshape([5,5])

	# print a1
	print("a1 at the beginning:\n{}".format(a1))

	# now, change the central element of a1 to 0
	a1[2:2]=0

	# print a1
	print("a1 after change:\n{}".format(a1))

	# print a0
	print("a0 after changing a1:\n{}".format(a0))
	print("reshaping doesn't create a copy of array. It just returns another view. So, changing one changed the other")

	# make a copy of a1 and flatten it (call it a1cpy)
	a1cpy=a1.copy()
	a1cpy=a1cpy.flatten()

	# multiply each element of a1cpy by 0.7:
	a1cpy=a1cpy*(0.7)
	np.around(a1cpy,2,a1cpy)

	# print a1cpy:
	print("a1cpy\n{}".format(a1cpy))

	# print a1:
	print("a1 after changing its copy:\n{}".format(a1))

# ---- Task (b) -------
# Do as directed in function:
# 'my_integer': an even integer
def incendio(my_integer):
	# create an array 'arng0' of shape (3,2) containing consecutive even numbers starting from 'my_integer', arranged along rows
        arng0=np.arange(my_integer,(my_integer+11),2).reshape(3, 2)
	# print arng0
	print("arng0\n{}".format(arng0))

	# create another array 'arng1' of shape ((4,3)) containing consecutive numbers starting from 'my_integer' arranged along columns:
        array=np.arange(my_integer,(my_integer+12),1).reshape(3, 4)
        arng1=array.T
	# print arng1
	print("arng1\n{}".format(arng1))

	# multiply transpose of arng0 with transpose of arng1 to get mult0:
        mult0=np.dot(arng0.T,array)
	# print mult0:	print("mult0\n{}".format(mult0))
        v0=mult0.min(axis=1)
        v0=np.array(v0)
	# take min of mult0 along its rows and store it in v0:

	# print v0's shape:
	print("shape of v0: \n{}".format(v0.shape))

	# reshape v0 to make it a column vector:
        v0 = np.array([v0])
        v0=v0.T
	# subtract v0 from each column of mult0 and store it in base0:
        base0=mult0-v0
	# print base0
	print("base0\n{}".format(base0))

	# square all the elements present in base0
        base0=np.square(base0)
	# store the sum of all elements of base0 in ans
        ans=np.sum(base0)
	# print ans
	print("ans : {}".format(ans))


# ---- Task (c) -------
# 'n': integer
# 'm': integer that divides n
# return type: int numpy Ndarray; dim: nxn
def alohomora(n, m):
        a = np.zeros(n*n).reshape(n,n)
        b = np.ones(m*m).reshape(m,m)
        temp=0
        for i in range(0,n,m):
            if temp%2==0:
                for j in range(0,n,2*m):
                    a[i:i+m,j:j+m]=b
            else:
                for j in range(m,n,2*m):
                    a[i:i+m,j:j+m]=b
            temp=temp+1
            
        return a
# ---- Task (d) -------
# 'arr': float Ndarray; dim: Nx3, 
# 'theta': float; 0≤theta<360 (in degrees)
# 'axis': str; axis ∈ {'X','Y','Z'}
# return type: float Ndarray; dim: Nx3
def expelliarmus(arr, theta, axis):

	c1=math.cos(math.radians(theta),2)
	s1=math.sin(math.radians(theta),2)
	s=np.array([s1,c1],dtype='float32')
	s=s.transpose()
	c=np.array([c1,(-1)*s1],dtype='float32')
	c=c.transpose()

	c=np.concatenate([c,s],axis=1)
	if axis=='X' or axis=='x':
		arr2=arr[:,[1,2]]
		arr[:,1]=np.matmul(arr2,c)
		arr[:,2]=np.matmul(arr2,s)
	elif axis=='Y' or axis=='y':
		arr2=arr[:,[2,0]]
		arr[:,0]=np.matmul(arr2,s)
		arr[:,2]=np.matmul(arr2,c)
	elif axis=='Z' or axis=='z' :
		arr2=arr[:,[0,1]]
		arr[:,0]=np.matmul(arr2,c)
		arr[:,1]=np.matmul(arr2,s)
	arr=np.round(arr,2)
	return arr	


# ---- Task (e) -------
# 'arr': float Ndarray; dim: MxN
# return type: float Ndarray; dim: MxN
def crucio(arr):
        a=np.array(arr)
        mean=np.mean(a, axis = 0)
        mean=np.array(mean)
        std=np.std(a,axis=0)
        std=np.array(std)
        b=a-mean
        norm=b/std
        return norm
	


# ---- Task (f) -------
# 'arr': int 1-D array; dim: (n,)
# k: integer
# return type: int 1-D array; dim: (n+k-1,)
def leviosa(arr, k):
        v=v=np.ones(k)
        array=np.convolve(arr, v)
        return array
	


# ---- Task (g) -------
# 'mat': int n-D array; dim: (m,n)
# k: integer
# return type: n-D integer array; dim: (m,k)
def accio(mat, k):
	return np.argsort(mat,axis=1)[:,-k:][:,[1,0]]
